
#include <streams.h>
#include <initguid.h>

#include "Guids.h"
#include "FramesFromFileSourceFilter.h"

// Filter setup data
const AMOVIESETUP_MEDIATYPE sudOpPinTypes =
{
	&MEDIATYPE_Video,       // Major type
	&MEDIASUBTYPE_NULL      // Minor type
};


const AMOVIESETUP_PIN sudOutputPinBitmap = 
{
	L"Output",      // Obsolete, not used.
	FALSE,          // Is this pin rendered?
	TRUE,           // Is it an output pin?
	FALSE,          // Can the filter create zero instances?
	FALSE,          // Does the filter create multiple instances?
	&CLSID_NULL,    // Obsolete.
	NULL,           // Obsolete.
	1,              // Number of media types.
	&sudOpPinTypes  // Pointer to media types.
};

const AMOVIESETUP_FILTER sudFramesFromFileSourceBitmap =
{
	&CLSID_FramesFromFileSourceFilter,	// Filter CLSID
	g_wszFramesFromFileSourceFilter,	// String name
	MERIT_DO_NOT_USE,					// Filter merit
	1,									// Number pins
	&sudOutputPinBitmap					// Pin details
};


const AMOVIESETUP_PIN sudOutputPinBitmapSet = 
{
	L"Output",      // Obsolete, not used.
	FALSE,          // Is this pin rendered?
	TRUE,           // Is it an output pin?
	FALSE,          // Can the filter create zero instances?
	FALSE,          // Does the filter create multiple instances?
	&CLSID_NULL,    // Obsolete.
	NULL,           // Obsolete.
	1,              // Number of media types.
	&sudOpPinTypes  // Pointer to media types.
};

const AMOVIESETUP_PIN sudOutputPinDesktop = 
{
	L"Output",      // Obsolete, not used.
	FALSE,          // Is this pin rendered?
	TRUE,           // Is it an output pin?
	FALSE,          // Can the filter create zero instances?
	FALSE,          // Does the filter create multiple instances?
	&CLSID_NULL,    // Obsolete.
	NULL,           // Obsolete.
	1,              // Number of media types.
	&sudOpPinTypes  // Pointer to media types.
};

CFactoryTemplate g_Templates[1] = 
{
	{ 
		g_wszFramesFromFileSourceFilter,			// Name
		&CLSID_FramesFromFileSourceFilter,			// CLSID
		FramesFromFileSourceFilter::CreateInstance,	// Method to create an instance of MyComponent
		NULL,										// Initialization function
		&sudFramesFromFileSourceBitmap				// Set-up information (for filters)
	},
};

int g_cTemplates = sizeof(g_Templates) / sizeof(g_Templates[0]);    


STDAPI DllRegisterServer() {
	return AMovieDllRegisterServer2(TRUE);
}

STDAPI DllUnregisterServer() {
	return AMovieDllRegisterServer2(FALSE);
}

//
// DllEntryPoint
//
extern "C" BOOL WINAPI DllEntryPoint(HINSTANCE, ULONG, LPVOID);

BOOL APIENTRY DllMain(HANDLE hModule, DWORD  dwReason, LPVOID lpReserved) {
	return DllEntryPoint((HINSTANCE)(hModule), dwReason, lpReserved);
}
